Download it now!
Bug 114227 - Proxy settings disregarded for reporting crashes
Summary: Proxy settings disregarded for reporting crashes
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
5.3 all versions
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:6.1.0 target:6.2.0 target:6.1.0.1
Keywords:
Depends on:
Blocks: Crash-Report
  Show dependency treegraph
 
Reported: 2017-12-04 03:28 UTC by Aron Budea
Modified: 2018-06-30 17:29 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Aron Budea 2017-12-04 03:28:42 UTC
- Set a non-existent proxy in LibreOffice (Tools -> Options...; Internet -> Proxy), eg. select Manual proxy server, and set 127.0.0.1 / 8080 both for HTTP and HTTPS.
- Provoke a crash. (bug 111187 is a good candidate at the moment)
- Report crash.

=> Crash is reported fine, while it should fail due to the false proxy settings.

Can be tested in the opposite way as well, if the internet is only available through a proxy, setting the server (or using the default setting: System) should work, but it doesn't.

The details for the crash about to be reported (before hitting Submit) are stored in <profile>/dump.ini. It can be verified with a text editor that the INI file contains no proxy details.
The config reader is prepared to read Proxy details, see the uploadContent(...) function: https://opengrok.libreoffice.org/xref/core/desktop/source/minidump/minidump.cxx#85

Reporting crashes through a proxy can be manually tested by adding the following to the dump.ini before submitting the crash report (the report can also be manually submitted using minidump_upload from the program dir, and giving the location of dump.ini as parameter):

Proxy=http://<proxy ip>:<proxy port>
or
Proxy=https://<proxy ip>:<proxy port>

My experience with a local setup of a simple proxy [1] is that the following line works, despite that the crash reporting is done via https (this might be another bug?):
Proxy=http://<proxy ip>:<proxy port>

I also encountered a proxy setup (details are unknown apart from server and port, coming from proxy configuration script) where crash reporting was unsuccessful even after manually setting the proxy as above.

Observed using LO 6.0beta1 & 5.4.3.2 / Windows 7.

[1] http://www.analogx.com/contents/download/Network/proxy/Freeware.htm
Comment 1 Michael Meeks 2018-03-15 16:34:17 UTC
The first problem - of not including the proxy settings is presumably fixable; but the 2nd - is harder (I guess) firefox had some similar issues:

https://bugzilla.mozilla.org/show_bug.cgi?format=default&id=464429

and:

https://bugs.chromium.org/p/google-breakpad/issues/detail?id=232
Comment 2 Aron Budea 2018-04-27 13:40:25 UTC
There is an incomplete patch on gerrit:
https://gerrit.libreoffice.org/#/c/51621/

This handles the fixed proxy setting coming from LibreOffice, but that is highly undesirable because of a serious problem with that dialog: bug 33697.
Additionally, it doesn't handle automatic configuration scripts, because ucbhelper::InternetProxyDecider can't handle those, either.

Adding that support would be a large-scale change with risks, plus rounding out the OS-dependent parts might be difficult. And for crash reporter, Windows is the most important, so adding a Windows-specific query in CrashReporter::writeCommonInfo() could be a sufficient measure (maybe WinHttpGetProxyForUrl() [1]). If that returns no proxy, then LO setting can be queried, otherwise use what Windows provides.

[1] https://msdn.microsoft.com/en-us/library/windows/desktop/aa384097(v=vs.85).aspx
Comment 3 Commit Notification 2018-05-16 08:47:28 UTC
Aron Budea committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=07174b62c6ee23f7b44742ecfe44d4ff8653e57f

tdf#114227: set better proxy params in cURL for crash reporting

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 4 Xisco Faulí 2018-06-18 15:18:44 UTC
A polite ping to Aron Budea:
Is this bug fixed? if so, could you please close it as RESOLVED FIXED ? Otherwise, Could you please explain what's missing?
Thanks
Comment 5 Aron Budea 2018-06-19 00:09:47 UTC
Comment 2 still applies, let's keep this open.
Comment 6 Commit Notification 2018-06-26 07:34:08 UTC
Mike Kaganski committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2e142c0ee54744d35517f0b9c49a24302fb32d47

tdf#114227: Add support for PAC to ucbhelper::InternetProxyDecider on Windows

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2018-06-29 06:27:22 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0e375686e2f2c6c626f50c06c5323c0982d7f602

tdf#114227 Add support for OS proxy to ucbhelper::InternetProxyDecider on Unix

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2018-06-30 17:29:09 UTC
Mike Kaganski committed a patch related to this issue.
It has been pushed to "libreoffice-6-1":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=76c0b3c516f6b0d43136522b4d476eb60211cec1&h=libreoffice-6-1

tdf#114227: Add support for PAC to ucbhelper::InternetProxyDecider on Windows

It will be available in 6.1.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.